![CalipeL](https://bitbucket.org/janvrany/jv-calipel/raw/71925d2ae258ffe413e495ea680e65a1834b4c13/web/public/images/logo.png)

*Benchmarking made easy*

CalipeL is a simple tool to ease development and maintenance
of benchmarks and performance regressions. CalipeL has been heavily 
inspired by [SUnit][1] and [Caliper][2]

The basic ideas that drove the development:

- Benchmarking and (especially) interpreting benchmark results is always
  a monkey business. The tool should produce raw numbers, letting the 
  user to use whichever statistics she needs to make up (desired) results. 
- Benchmark results should be kept and managed at a single place so one
  can view and retrieve all past benchmark results pretty much the same
  way as one can view and retrieve past versions of the software from 
  a source code management tool. 

## Features

- *simple* - creating a benchmark is as simple as writing a method in a class
- *flexible* - a special set-up and/or warm-up routines could be specified at benchmark-level as well as set of parameters to allow fine-grained measurements
under different conditions 
- *batch runner* - contains a batch runner allowing one to run benchmarks from a command line or at CI servers such as Jenkins. 
- *web* - comes with simple web interface to gather and process benchmark results. [Example...](https://swing.fit.cvut.cz/calipel)

## Supported Languages / Runtimes

* [Smalltalk/X jv-branch][6]
* [Pharo][5]

Planned (would be nice if somebody does it)

* Java (on hold)
* Ruby
* Python

## Installation

See [Installation instruction](https://bitbucket.org/janvrany/jv-calipel/wiki/Installation.md) on [wiki][3].

## More Information

...could be found on [wiki][3].

## Authors

* Jan Vraný `<jan.vrany [*] fit.cvut.cz>`
* Marcel Hlopko `<marcel [*] hlopko.com>`

[1]: http://sunit.sourceforge.net/
[2]: https://code.google.com/p/caliper/
[3]: https://bitbucket.org/janvrany/jv-calipel/wiki/Home
[4]: http://www.exept.de/de/products/smalltalkx
[5]: http://www.pharo-project.org/home
[6]: https://swing.fit.cvut.cz/projects/stx-jv/