class ResultsFilter
  include ActiveModel::Model

  attr_accessor :benchmark_configurations, :tags

  def initialize(*args)
    super

    @benchmark_configurations ||= {}
    @tags ||= {}
  end

  def benchmark_configurations_relation
    BenchmarkConfiguration.where(id: benchmark_configurations.compact)
  end

  def filtered_batches
    BenchmarkBatch.
      includes(
        :tags,
        :benchmark_configuration,
        benchmark_results: [
          :benchmark_durations,
          :benchmark_info
        ]).
      where(benchmark_configuration_id: benchmark_configurations.compact).
      order("performed_at desc")
  end

end
